"""
Created by kevin-desktop, on the 28/09/2023
"""
import unittest
from functions import add, fibo, factorial, \
    count_vowels  # Replace 'your_module_name' with the name of your module


class TestFunctions(unittest.TestCase):

    # Test cases for add function
    def test_add(self):
        self.assertEqual(add(3, -2), 1, "Integers addition failed")
        self.assertAlmostEqual(add(1 / 3, 1 / 2), 0.8333333333333333, places=6,
                               msg="Floats addition failed")
        self.assertTrue(isinstance(add("doc", "strings"), str),
                        "Return type is not string")
        self.assertNotEqual(add(3, 3), 7,
                            "Integers addition result is not as expected")

    # Test cases for fibo function
    def test_fibo(self):
        self.assertEqual(fibo(0), 0, "Fibo for 0 failed")
        self.assertEqual(fibo(10), 55, "Fibo for 10 failed")

    # Test cases for factorial function
    def test_factorial(self):
        self.assertIn(factorial(5), [120], "Factorial of 5 failed")
        self.assertNotIn(factorial(5), [121, 119],
                         "Factorial of 5 had unexpected results")


if __name__ == '__main__':
    unittest.main()
